@ECHO off
:: Checking if all files are present
IF NOT EXIST "nand.bin" (
    color 4
    echo nand.bin non detecte!
    echo Placer votre "nand.bin" dans le dossier autofirm
    pause
    exit /b 1
)
color 3
ECHO.
ECHO                        ----------------------------------
ECHO                        *  3DS AUTOFIRM - GUIDE EDITION  *
ECHO                                  version French
ECHO                        ----------------------------------
ECHO.
ECHO.
ECHO    INSTRUCTIONS:
ECHO.
ECHO  - Votre fichier NAND.BIN doit etre dans le meme dossier que autofirm.bat
ECHO    Vous devez extraire votre nand.bin via un dump Hardware.
ECHO    Guide Hardmod: https://gbatemp.net/threads/414498/
ECHO    Kit Hardmod : http://www.consolex-bordeaux.fr
ECHO.
ECHO  - NATIVE-FIRMs decrypte doivent etre dans "source\firmwares\" folder.
ECHO    Vous pouvez telecharger les fichiers https://git.io/vo5OS
ECHO.
ECHO  - Traduit en Francais par ConsoleX Bordeaux
ECHO.
ECHO.
ECHO Appuyez sur un bouton lorsque vous etes pret !
pause
cls
ECHO.
ECHO                        ----------------------------------
ECHO                        *  3DS AUTOFIRM - GUIDE EDITION  *
ECHO                                  version French
ECHO                        ----------------------------------
ECHO.
ECHO.
ECHO    SELECTIONNER VOTRE MODELE DE CONSOLE ET VERSION FIRMWARE:
ECHO.
ECHO  1) 11.0.0 - OLD 3DS/XL or 2DS
ECHO.
ECHO  2) 11.1.0 - OLD 3DS/XL or 2DS
ECHO.
ECHO. 3) 11.2.0 - OLD 3DS/XL or 2DS
ECHO.
ECHO  4) 11.0.0 - NEW 3DS/XL
ECHO.
ECHO  5) 11.1.0 - NEW 3DS/XL
ECHO.
ECHO  6) 11.2.0 - NEW 3DS/XL
ECHO.
ECHO.
ECHO.
SET /p option= Entrer le numero correspondant a votre config:
IF "%option%"=="1" (
    SET firm0="source\firmwares\firm110_OLD.bin"
    SET firm1="source\firmwares\firm104_OLD.bin"
) ELSE IF "%option%"=="2" (
    SET firm0="source\firmwares\firm111_OLD.bin"
    SET firm1="source\firmwares\firm104_old.bin"
) ELSE IF "%option%"=="3" (
    SET firm0="source\firmwares\firm112_OLD.bin"
    SET firm1="source\firmwares\firm104_OLD.bin"
) ELSE IF "%option%"=="4" (
    SET firm0="source\firmwares\firm110_NEW.bin"
    SET firm1="source\firmwares\firm104_NEW.bin"
) ELSE IF "%option%"=="5" (
    SET firm0="source\firmwares\firm111_NEW.bin"
    SET firm1="source\firmwares\firm104_NEW.bin"
) ELSE IF "%option%"=="6" (
    SET firm0="source\firmwares\firm112_NEW.bin"
    SET firm1="source\firmwares\firm104_NEW.bin"
) ELSE (
    exit /b 1
)
cls
IF NOT EXIST %firm0% (
    goto firmError
)
ECHO Creation d'une copie de sauvegarde du fichier NAND.bin...
copy nand.bin source\nand.bin
ECHO Done.
ECHO [** Running 3DSFirm.exe **] > log.txt
source\3DSFirm.exe -d source\nand.bin source\tmp\firm0.bin source\tmp\firm1.bin >> log.txt
IF ERRORLEVEL 1 GOTO error
ECHO [** Success! **] >> log.txt
ECHO [** Running 1st XOR **] >> log.txt
source\xor source\tmp\firm0.bin %firm0% >> log.txt
IF ERRORLEVEL 1 GOTO error
ECHO [** Success! **] >> log.txt
ECHO [** Running 2nd XOR **] >> log.txt
source\xor source\tmp\firm0.bin.out %firm1% >> log.txt
IF ERRORLEVEL 1 GOTO error
ECHO [** Success! **] >> log.txt
ECHO [** Running 3rd XOR **] >> log.txt
source\xor source\tmp\firm1.bin %firm0% >> log.txt
IF ERRORLEVEL 1 GOTO error
ECHO [** Success! **] >> log.txt
ECHO [** Running 4th XOR **] >> log.txt
source\xor source\tmp\firm1.bin.out %firm1% >> log.txt
IF ERRORLEVEL 1 GOTO error
ECHO [** Success! **] >> log.txt
ECHO [** Renaming files **] >> log.txt
ren source\tmp\firm0.bin.out.out firm0new.bin
ren source\tmp\firm1.bin.out.out firm1new.bin
ECHO [** Success! **] >> log.txt
ECHO [** Running final 3DSFirm.exe **] >> log.txt
source\3DSFirm.exe -i source\nand.bin source\tmp\firm0new.bin source\tmp\firm1new.bin >> log.txt
IF ERRORLEVEL 1 GOTO error
ECHO [** Success! **] >> log.txt
move /Y source\nand.bin nand_patched.bin
del /F /Q source\tmp\*.bin*
ECHO [** Temp files deleted **] >> log.txt
cls
ECHO.
ECHO                        ----------------------------------
ECHO                        *  3DS AUTOFIRM - GUIDE EDITION  *
ECHO                                  version French
ECHO                        ----------------------------------
ECHO.
ECHO.
ECHO    Un fichier patche "nand_patched.bin" a ete genere.
ECHO.
ECHO    ***************************************************************
ECHO    * FLASHER VOTRE FICHIER "nand_patched.bin" DANS VOTRE 3DS/2DS *
ECHO    ***************************************************************
ECHO.
ECHO    Si quelque chose se passe mal, vous pouvez restaurer le fichier "NAND.bin"
ECHO    Votre 3DS/2DS sera restaure dans le firmware d'origine.
ECHO.
ECHO    This batch file is based on the REBOOT.MS's Autofirm.
ECHO    REBOOT.MS's Autofirm is based on the Raugo's original Autofirm.
ECHO.
pause
exit

:error
    color 4
    cls
    ECHO [** Error! **] >> log.txt
    ECHO.
    ECHO                        ----------------------------------
    ECHO                        *  3DS AUTOFIRM - GUIDE EDITION  *
    ECHO                        ----------------------------------
    ECHO.
    ECHO.
    ECHO    Something went wrong! Do not flash "nand_patched.bin" to your system!
    ECHO    If you do, your system will be bricked!
    ECHO    Please look at the "log.txt" file to see where the error occured!
    ECHO    If you need help, go to "gbatemp.net" and include the "log.txt" file.
    ECHO.
    pause
    exit /b 1

:firmError
    color 4
    cls
    ECHO [** Error! %firm0% doesn't exist! **] >> log.txt
    ECHO.
    ECHO                        ----------------------------------
    ECHO                        *  3DS AUTOFIRM - GUIDE EDITION  *
    ECHO                        ----------------------------------
    ECHO.
    ECHO.
    ECHO    I could not find FIRM file %firm0%!
    ECHO    Do not flash "nand_patched.bin" to your system!
    ECHO    If you do, your system will be bricked!
    ECHO    Please download the necessary FIRM file from: https://git.io/vo5OS
    ECHO.
    pause
    exit /b 1
